#include "treeh.h"

//initializers & destroyer
tree make_empty_tree(){
  return NULL;
}
node* make_empty_node(){
  node*n=malloc(sizeof(node));
  n->letter='\0';
  n->isEnd=0;
  for(int i=0;i<NBCHAR;i++)
    n->next[i]=make_empty_tree();
	return n;
}
node* make_node(char l,byte end){
  node*n=malloc(sizeof(node));
  n->letter=l;
  n->isEnd=end;
  for(int i=0;i<NBCHAR;i++)
    n->next[i]=make_empty_tree();
  return n;
}
void delete_tree(tree t){
  if(is_empty(t))return;
  for(int i=0;i<NBCHAR;i++)
    delete_tree(t->next[i]);
  free(t);
}





//Casual functions
bool is_empty(const tree t){
  return t==NULL;
}
bool is_followed(const tree t){
  int i;
  for(i=0;i<NBCHAR;i++){
    if(t->next[i]!=NULL)
      return true;
  }
  return false;
}

//functions is_end
bool is_end(const tree t){return t->isEnd;}
bool is_straight_end(const tree t){return t->isEnd & STRAIGHT_END;}
bool ends_with_apostrophe(const tree t){return t->isEnd & APOSTROPHE_END;}
 
bool is_common_end(const tree t){return t->isEnd & COMMON_END ;}
bool is_proper_end(const tree t){return t->isEnd & PROPER_END;}
bool is_acronyme_end(const tree t){return t->isEnd & ACRONYME_END;}



//needs to check c wether isalpha
int hash(char c){return c%32-1;}
bool ischar_of_word(char c){return isalpha(c) || c=='\'';}

byte end_kind(const string s){
  byte endKind;
  int i=1;
  //1st, let's consider all letters
  if(!isalpha(s[0]))
    return NOT_AN_END;
  
  if(islower(s[0])){
    endKind=COMMON_END;
    while(islower(s[i]))i++;
  }
  else {//if isupper(s[0])
    if(isalpha(s[1])){
      i++;
      if(islower(s[1])){
	endKind=PROPER_END;
	while(islower(s[i]))i++;
      }
      else{//if isupper(s[1])
	endKind=ACRONYME_END;
	while(isupper(s[i]))i++;
	endKind=16;
      }
    }
  }
  //then let's consider the end
  if(s[i]=='\0')
    return endKind & STRAIGHT_END;
  if(s[i]=='\''&&s[i+1]=='s'&&s[i+2]=='\0')
    return endKind & APOSTROPHE_END;
  return NOT_AN_END;
}
bool is_word(const byte endKind){
  return endKind!=0;
}





bool addto_treeIT(tree*t,const string word ,byte endKind){
  bool isIn;
  int i;
  //1st, let's go through the tree, until the word is not in tree
  for(i=1; word[i]!='\0' && word[i]!='\'' && !is_empty(*t) ;i++){
    t=&((*t)->next[hash(word[i])]);
  }
  printf("hi\n");
  //if word is not ended at the end of the tree
  if(is_empty(*t)){
    isIn=false;
    for(; word[i]!='\0' && word[i]!='\'';i++){
      *t=make_node(tolower(word[i]),NOT_AN_END);
      t=&((*t)->next[hash(word[i])]);
    }
    (*t)->isEnd=endKind;
    printf("actions ended\n");
  }
  //if word is ended
  else{
    isIn=endKind & is_end(*t);
    (*t)->isEnd=endKind | is_end(*t);
    printf("action ended\n");
  }
  return isIn;
}
 
